# GraphQL Code Generator Example with React and Apollo Client

This is an example repo for how to use GraphQL Code Generator together with:

- [TypeScript](https://www.typescriptlang.org/)
- [React](https://reactjs.org/)
- [Apollo Client](https://www.apollographql.com/docs/react/)
- [Nhost](http://nhost.io/)

This repo is a reference repo for the blog post: [How to use GraphQL Code Generator with React and Apollo](https://nhost.io/blog/how-to-use-graphql-code-generator-with-react-and-apollo).

## Get Started

1. Clone the repository

```
git clone https://github.com/nhost/nhost
cd nhost
```

2. Install and build dependencies

```
pnpm install
pnpm build
```

3. Go to the Codegen React Apollo example folder

```
cd examples/codegen-react-apollo
```

4. Terminal 1: Start Nhost

> Make sure you have the [Nhost CLI installed](https://docs.nhost.io/platform/cli).

```sh
nhost up
```

5. Terminal 2: Run GraphQL Codegen

```
pnpm codegen -w
```

> `-w` runs [codegen in watch mode](https://www.the-guild.dev/graphql/codegen/docs/getting-started/development-workflow#watch-mode).

6. Terminal 3: Start the React application

```sh
pnpm dev
```
